
/*
 *  cp_new_by_name.c - instantiation by name
 *
 *  Copyright (c) 1993 Symantec Corporation.  All rights reserved.
 *
 */

#include <MacHeaders>
#define OOPS_PRIVATE
#include "oops.h"

extern void *__nw__12PascalObjectFPvUi(...);


/*
 *  new_by_name - create an object given the name of its class
 *
 */

void *
new_by_name(char *name)
{
	struct { void *min, *max; } range;
	register void *p, *q;

	asm {

;;
;
;  establish search range
;
;;

#if __A4_GLOBALS__
		movea.l	a4,a0
		_RecoverHandle
		_GetHandleSize
		move.l	a4,range.min
		add.l	a4,d0
		move.l	d0,range.max
#else
		move.l	CurStackBase,range.min
		move.l	a5,range.max
#endif

;;
;
;  search data area for matching name (this could probably be improved)
;
;;

		movea.l	range.min,p
		movea.l	name,q
		move.w	(q)+,d1					;  D1.W = 1st two bytes of name
@1		cmp.w	(p)+,d1
		beq.s	@2
		cmpa.l	range.max,p
		blo.s	@1
;
		moveq	#0,d0					;  search failed
		return
;
@2		movea.l	p,a0
		movea.l	q,a1
		bra.s	@4
@3		cmpm.b	(a0)+,(a1)+
		bne.s	@1						;  name not found - keep looking
@4		tst.b	-1(a1)
		bne.s	@3

;;
;
;  verify we've found a class info record
;
;	- at entry, p = start of found name plus 2
;	- verify by looking back before name. First check for '.', then look
;	  for 'CLASINFO'
;	- be careful on 68000; use cmpi.l only on even boundry
;;
		movea.l	p, a0
		subq.l	#2, a0
		cmpi.l	#'NFO.',-(a0)
		bne.s	@1
		cmpi.l	#'LASI', -(a0)
		bne.s	@1
		cmpi.b	#'C', -(a0)
		bne.s	@1
		subq.l	#1, a0					; skip length byte


;	Things are looking good. now we scan backwards through the methtable,
;	looking for a pointer that points to itself.
;
;	We can move two entries at at a time, starting with the first half
;	of the last entry

	#ifdef BASE_REG
@5		subq	#4, a0
		cmpa.l	range.min, a0
		blo.s	@1						; search failed!
		movea.w	(a0), a1
		adda.l	BASE_REG, a1
		cmpa.l	a0, a1
		bne.s	@5
	#else
@5		subq	#4, a0
		cmpa.l	range.min, a0
		blo.s	@1						; search failed!
		cmpa.l	(a0), a0
		bne.s	@5
	#endif

;	Could perform more checks here.

;;
;
;  create object
;
;;

	#ifdef BASE_REG
		move.w	4(a0), d0
	#else
		move.w	8(a0), d0
	#endif
		ext.l	d0
		move.l	d0, -(sp)
		move.l	a0, -(sp)
		jsr		__nw__12PascalObjectFPvUi
		addq.l	#8,sp
	}
}


/*
 *  __cp_class_name - get the name of an object's class
 *
 *	Unlike THINK C's version, this function is called with the object
 *	handle itself, not the class ID.
 *
 */

static void dummy()
{
	asm {

extern __cp_class_name:
		movea.l	4(sp), a0
		movea.l	(a0), a0				;	extra deref for handle based objects
		movea._	(a0), a0
	#ifdef BASE_REG
		adda.l	a5, a0
		move.w	6(a0), d0				;	D0 ==> number of methods
		addq	#8, a0					;	A0 ==> dispatch table
	#else
		move.w	10(a0), d0
		lea		12(a0), a0
	#endif
		lsl.w	#DSHIFT, d0
		adda.w	d0, a0					;	A0 ==> class info
		moveq	#10, d0					;	skip length byte, 'CLASINFO', '.' byte
		add.l	a0, d0					;	D0 ==> class name
	}
}
